#!/usr/bin/env python
# _*_ coding:utf-8 _*_

'''
 Copyright: 2016-2018 ROS小课堂 www.corvin.cn
 Author: corvin
 Description:
    用于手柄可以使用dynamic_reconfigure,这样就可以动态的调整手柄的参数.
 History:
    20181115: initial this comment.
'''

import rospy

from dynamic_reconfigure.server import Server
from ros_handle_python.cfg import handleConfig

def callback(config, level):
    rospy.loginfo("Dynamic_reconfig_server:topic_name:{cmd_topic_name},public_rate:{cmd_public_rate},angular_z:{angular_z},linear_x:{linear_x}".format(**config))
    return config

if __name__ == "__main__":
    rospy.init_node("handle_dynamic_reconfig", anonymous=True)

    srv = Server(handleConfig, callback)
    rospy.spin()
